---
title: Element.computedStyleMap()
slug: Web/API/Element/computedStyleMap
tags:
  - API
  - CSS Typed Object Model API
  - Element
  - Experimental
  - Houdini
  - Method
  - Reference
  - StylePropertyMapReadOnly
  - computedStyleMap()
---
<p>{{APIRef("CSS Typed Object Model API")}}{{SeeCompatTable}}</p>

<p><span class="seoSummary">The <strong><code>computedStyleMap()</code></strong> method of the {{domxref("Element")}} interface returns a {{domxref("StylePropertyMapReadOnly")}} interface which provides a read-only representation of a CSS declaration block that is an alternative to {{domxref("CSSStyleDeclaration")}}. </span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>stylePropertyMapReadOnly</var> = Element.computedStyleMap()</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("StylePropertyMapReadOnly")}} interface.</p>

<h2 id="Examples">Examples</h2>

<p>We start with some simple HTML: a paragraph with a link, and a definition list to which we will add all the CSS Property / Value pairs.</p>

<pre class="brush: html">&lt;p&gt;
   &lt;a href="https://example.com"&gt;Link&lt;/a&gt;
&lt;/p&gt;
&lt;dl id="regurgitation"&gt;&lt;/dl&gt;</pre>

<p>We add a little bit of CSS</p>

<pre class="brush: css">a {
  --colour: red;
  color: var(--colour);
}</pre>

<p>We add JavaScript to grab our link and return back a definition list of all the CSS property values using <code>computedStyleMap().</code></p>

<pre class="brush: js">// get the element
const myElement = document.querySelector('a');

// get the &lt;dl&gt; we'll be populating
const stylesList = document.querySelector('#regurgitation');

// Retrieve all computed styles with computedStyleMap()
const allComputedStyles = myElement.computedStyleMap();

// iterate thru the map of all the properties and values, adding a &lt;dt&gt; and &lt;dd&gt; for each
for (const [prop, val] of allComputedStyles) {
	// properties
	const cssProperty = document.createElement('dt');
	cssProperty.appendChild(document.createTextNode(prop));
	stylesList.appendChild(cssProperty);

	// values
	const cssValue = document.createElement('dd');
	cssValue.appendChild(document.createTextNode(val));
	stylesList.appendChild(cssValue);
}</pre>

<p>In <a href="/en-US/docs/Web/API/Element/computedStyleMap#Browser_compatibility">browsers that support <code>computedStyleMap()</code></a>, you'll see a list of all the CSS properties and values. In other browsers you'll just see a link.</p>

<p>{{EmbedLiveSample("Examples", 300, 300)}}</p>

<p>Did you realize how many default CSS properties a link had? Update the '<code>a</code>' to the '<code>p</code>', and you'll notice a difference in the <code>margin-top</code> and <code>margin-bottom</code> default computed values.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSS Typed OM','#dom-element-computedstylemap','computedStyleMap()')}}</td>
   <td>{{Spec2('CSS Typed OM')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.computedStyleMap")}}</p>
